#!/usr/bin/python
import sqlite3
import xml.etree.ElementTree as ET
import socket


### This file is used to read rollback database and create a XML to sent to server
#
# DataBase Structure



print ("connectin to database")
## create database connection 
connection = sqlite3.connect("/var/lib/apt/rollback.bin")
cur = connection.cursor()
cur.execute("select pkgHistory.id,pkgHistory.parent,pkgHistory.op,pkgHistory.pkgName,pkgHistory.pkgVer1,pkgHistory.pkgVer2,pkgHistory.datetime, cmdHistory.commandExecuted  from pkgHistory left join cmdHistory on pkgHistory.parent = cmdHistory.parent  where pkgHistory.parent>1 order by pkgHistory.parent DESC ")

## intializing xml object to insert data
host = socket.gethostname()
root = ET.Element('apt-rollback-hist')
hostname = ET.SubElement(root,"hostname")
hostname.text = host

prev_transaction_parent="0"
for row in cur:
	if prev_transaction_parent!=row[1]: 
		#Transaction id=
		transaction= ET.SubElement(root,"transaction")
		transaction.set("id", str(row[1]))
		date= ET.SubElement(transaction,"date")
		date.text = str(row[6])
		command= ET.SubElement(transaction,"command")
		command.text = str(row[7])
		packagesInstalled= ET.SubElement(transaction,"packagesInstalled")
		prev_transaction_parent=row[1]
	
	#PackageName
	package = ET.SubElement(packagesInstalled,"package")
	package.set("name",str(row[3]))
	#Type (Install/upgrade)
	type = ET.SubElement(package,"type")
	type.text = str(row[2])
	#PackageVersion
	versionInstalled = ET.SubElement(package,"versionInstalled")
	versionInstalled.text = str(row[4])
	#Previous PackageVersion
	previousVersion = ET.SubElement(package,"previousVersion")
	previousVersion.text = str(row[5])

hostname.text = host
tree = ET.ElementTree(root)
tree.write('/root/client/src/apt-rollback.xml')

connection.close()



