#!/bin/bash -e

echo
echo "MANCOOSI APT-PULSE Project - auto-installation script (for client computers) "
echo

# Install pre-requisites
apt-get install -y openssh-server
apt-get install -y x11vnc
apt-get install -y ocsinventory-agent

# Make a Pulse Client
wget http://pulseserver/id_dsa.pub
mkdir -p /root/.ssh
cat id_dsa.pub >> /root/.ssh/authorized_keys
echo "ocsinventory-agent -server http://pulseserver:9999/ocsinventory & " >> /etc/rc.local
ln /usr/sbin/ocsinventory-agent /usr/bin/ocsinventory-agent
## Permit root login without-password
sed "s/PermitRootLogin no/PermitRootLogin without-password/g" /etc/ssh/sshd_config > /tmp/sshd_config.tmp
cp -f /tmp/sshd_config.tmp /etc/ssh/sshd_config
/etc/init.d/sshd restart
chkconfig sshd on
mkdir -p /usr/share/autostart
cp -f x11vnc.desktop /usr/share/autostart
rm -rf id_dsa.pub

# Add new table to rollback DB
python add_table_to_rollback_db.py

mkdir -p /root/client/src
cp apt-pulse/src/* /root/client/src/

## create script to autoconfigure client
mkdir -p /etc/mmc/pulse2
cp register_on_pulse-apt-server.sh /etc/mmc/pulse2

#creating Symbolic link to apt-get use my script instead of /usr/bin
ln -s /root/client/src/aux-apt-get.sh /sbin/apt-get
echo "Done"


